SystemOrganization addCategory: #'Collections-Tests-OrderPreservingDictionary'!

TestCase subclass: #StandardOrderedDictionaryTest
	instanceVariableNames: 'dictionaryAssociations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

!StandardOrderedDictionaryTest commentStamp: '<historical>' prior: 0!
This class tests the OrderPreservingDictionary class using an empty dictionary, one with a single association and one with multiple associations.!

StandardOrderedDictionaryTest subclass: #OrderPreservingDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

!OrderPreservingDictionaryTest class methodsFor: 'testing' stamp: 'monty 11/20/2014 19:24'!
shouldInheritSelectors
	^ true! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'monty 11/20/2014 18:48'!
defaultValue
	^ 'defaultValue'! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'monty 11/20/2014 18:50'!
dictionaryClass
	^ OrderPreservingDictionary! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'monty 11/20/2014 18:58'!
newDefaultValue
	^ 'newDefaultValue'! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 11/21/2014 05:13'!
testAssociationAt
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		assert: (dictionary associationAt: self absentKey) isNil;
		assert: (dictionary associationAt: self singleKey) = self singleAssociation.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 18:58'!
testAssociationsSelect
	super testAssociationsSelect.

	self assert:
		(self dictionaryWithAssociations
			defaultValue: self defaultValue;
			associationsSelect: [:each | true]) defaultValue = self defaultValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 18:53'!
testAt
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	dictionary defaultValue: self defaultValue.
	self
		assert: (dictionary at: self absentKey) = self defaultValue;
		assert: (dictionary at: self singleKey) = self singleValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 19:37'!
testCapacity
	| defaultCapacity |

	super testCapacity.
	defaultCapacity := self defaultCapacity.
	self
		assert: (self dictionaryClass defaultValue: nil) capacity >= defaultCapacity;
		assert:
			(self dictionaryClass
				new: defaultCapacity * 2
				withDefaultValue: nil) capacity >= (defaultCapacity * 2).! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 19:08'!
testCollect
	super testCollect.

	self assert:
		(self dictionaryWithAssociations
			defaultValue: self defaultValue;
			collect: [:each | each]) defaultValue = self defaultValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 19:11'!
testCopy
	| dictionary |

	super testCopy.
	(dictionary := self dictionaryWithAssociations)
		defaultValue: self defaultValue.
	self assert: dictionary copy defaultValue = dictionary defaultValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 19:11'!
testCopyEmpty
	| dictionary |

	super testCopyEmpty.
	
	(dictionary := self dictionaryWithAssociations)
		defaultValue: self defaultValue.
	self assert: dictionary copy defaultValue = self defaultValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 18:58'!
testDefaultValue
	| dictionary |
	
	dictionary :=  self dictionaryClass new: 10 withDefaultValue: self defaultValue.
	self assert: dictionary defaultValue = self defaultValue.

	dictionary := self dictionaryClass defaultValue: self defaultValue.
	self assert: dictionary defaultValue = self defaultValue.

	dictionary defaultValue: self newDefaultValue.
	self assert: dictionary defaultValue = self newDefaultValue.

	dictionary := (self dictionaryClass newFrom: dictionary).
	self
		assert: dictionary defaultValue = self newDefaultValue;
		assert: dictionary copy defaultValue = self newDefaultValue;
		assert: dictionary copyEmpty defaultValue = self newDefaultValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 19:05'!
testKeyAtIdentityValue
	| dictionary value |

	dictionary := self dictionaryWithSingleAssociation.
	dictionary defaultValue: self defaultValue.
	value := dictionary at: self singleKey.
	self
		assert: (dictionary keyAtIdentityValue: self absentValue) = self defaultValue;
		assert: (dictionary keyAtIdentityValue: value copy) = self defaultValue;
		assert: (dictionary keyAtValue: value) = self singleKey.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 19:07'!
testKeyAtIndex
	| dictionary |

	(dictionary := self emptyDictionary)
		defaultValue: self defaultValue.
	self
		assert: (dictionary keyAtIndex: 0) = self defaultValue;
		assert: (dictionary keyAtIndex: 1) = self defaultValue.

	(dictionary := self dictionaryWithAssociations)
		defaultValue: self defaultValue.
	self dictionaryKeys withIndexDo: [:each :i |
		self assert: (dictionary keyAtIndex: i) = each].
	self
		assert: (dictionary keyAtIndex: 0) = self defaultValue;
		assert: (dictionary keyAtIndex: dictionary size + 1) = self defaultValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 19:00'!
testKeyAtValue
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	dictionary defaultValue: self defaultValue.
	self
		assert: (dictionary keyAtValue: self absentValue) = self defaultValue;
		assert: (dictionary keyAtValue: self singleValue) = self singleKey.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 19:15'!
testNewFrom
	| dictionaryOne dictionaryTwo |

	super testNewFrom.
	(dictionaryOne := self dictionaryClass newFrom: self dictionaryAssociations)
		defaultValue: self defaultValue.
	dictionaryTwo := self dictionaryClass newFrom: dictionaryOne.
	self
		assertIsDictionary: dictionaryTwo withAssociations: self dictionaryAssociations;
		assert: dictionaryTwo defaultValue = self defaultValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 12/15/2014 16:01'!
testRemoveKey
	| dictionary associationsToRemove |

	(dictionary := self dictionaryWithAssociations)
		defaultValue: self defaultValue.
	self assert: (dictionary removeKey: self absentKey) = self defaultValue.
	associationsToRemove := self dictionaryAssociations asOrderedCollection.
	[associationsToRemove notEmpty]
		whileTrue: [ | removed |
			removed := associationsToRemove removeFirst.
			self
				assert: (dictionary removeKey: removed key) = removed value;
				assert: (dictionary removeKey: removed key) = self defaultValue;
				assertRemovedKey: removed key from: dictionary;
				assert: dictionary keys = (associationsToRemove collect: [:each | each key]) asArray].! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 18:57'!
testSelect
	super testSelect.

	self assert:
		(self dictionaryWithAssociations
			defaultValue: self defaultValue;
			select: [:each | true]) defaultValue = self defaultValue.! !

OrderPreservingDictionaryTest subclass: #OrderPreservingIdentityDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

!OrderPreservingIdentityDictionaryTest methodsFor: 'accessing' stamp: 'monty 10/18/2014 08:55'!
dictionaryClass
	^ OrderPreservingIdentityDictionary! !

!OrderPreservingIdentityDictionaryTest methodsFor: 'testing' stamp: 'monty 12/15/2014 16:44'!
isTestingIdentityDictionary
	^ true! !

StandardOrderedDictionaryTest subclass: #OrderPreservingStringDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

OrderPreservingStringDictionaryTest subclass: #OrderPreservingIdentityStringDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

!OrderPreservingIdentityStringDictionaryTest methodsFor: 'accessing' stamp: 'monty 11/20/2014 20:01'!
dictionaryClass
	^ OrderPreservingIdentityStringDictionary! !

!OrderPreservingIdentityStringDictionaryTest methodsFor: 'testing' stamp: 'monty 12/15/2014 16:44'!
isTestingIdentityDictionary
	^ true! !

!OrderPreservingStringDictionaryTest class methodsFor: 'testing' stamp: 'monty 11/20/2014 20:02'!
shouldInheritSelectors
	^ true! !

!OrderPreservingStringDictionaryTest methodsFor: 'accessing' stamp: 'monty 11/20/2014 19:55'!
dictionaryClass
	^ OrderPreservingStringDictionary! !

!OrderPreservingStringDictionaryTest methodsFor: 'tests' stamp: 'monty 11/21/2014 05:13'!
testAssociationAt
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		assert: (dictionary associationAt: self absentKey) isNil;
		assert: (dictionary associationAt: self singleKey) = self singleAssociation.! !

!OrderPreservingStringDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 19:56'!
testAt
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		assert: (dictionary at: self absentKey) isEmpty;
		assert: (dictionary at: self singleKey) = self singleValue.! !

!OrderPreservingStringDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 19:57'!
testKeyAtIdentityValue
	| dictionary value |

	dictionary := self dictionaryWithSingleAssociation.
	value := dictionary at: self singleKey.
	self
		assert: (dictionary keyAtIdentityValue: self absentValue) isEmpty;
		assert: (dictionary keyAtIdentityValue: value copy) isEmpty;
		assert: (dictionary keyAtValue: value) = self singleKey.! !

!OrderPreservingStringDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 19:58'!
testKeyAtIndex
	| dictionary |

	self
		assert: (self emptyDictionary keyAtIndex: 0) isEmpty;
		assert: (self emptyDictionary keyAtIndex: 1) isEmpty.

	dictionary := self dictionaryWithAssociations.
	self dictionaryKeys withIndexDo: [:each :i |
		self assert: (dictionary keyAtIndex: i) = each].
	self
		assert: (dictionary keyAtIndex: 0) isEmpty;
		assert: (dictionary keyAtIndex: dictionary size + 1) isEmpty.! !

!OrderPreservingStringDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 19:58'!
testKeyAtValue
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		assert: (dictionary keyAtValue: self absentValue) isEmpty;
		assert: (dictionary keyAtValue: self singleValue) = self singleKey.! !

!OrderPreservingStringDictionaryTest methodsFor: 'tests' stamp: 'monty 12/15/2014 16:01'!
testRemoveKey
	| dictionary associationsToRemove |

	dictionary := self dictionaryWithAssociations.
	self assert: (dictionary removeKey: self absentKey) isEmpty.
	associationsToRemove := self dictionaryAssociations asOrderedCollection.
	[associationsToRemove notEmpty]
		whileTrue: [ | removed |
			removed := associationsToRemove removeFirst.
			self
				assert: (dictionary removeKey: removed key) = removed value;
				assert: (dictionary removeKey: removed key) isEmpty;
				assertRemovedKey: removed key from: dictionary;
				assert: dictionary keys = (associationsToRemove collect: [:each | each key]) asArray].! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 12/15/2014 16:44'!
absentKey
	self isTestingIdentityDictionary
		ifTrue: [^ self identityAbsentKey]
		ifFalse: [^ self nonIdentityAbsentKey]! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/19/2011 20:09'!
absentValue
	^ 'absentValue'! !

!StandardOrderedDictionaryTest methodsFor: 'assertions' stamp: 'JAAyer 12/4/2010 21:14'!
assertDictionary: aDictionary doesNotEqual: aSecondDictionary
	self
		deny: aDictionary = aSecondDictionary;
		deny: aSecondDictionary = aDictionary! !

!StandardOrderedDictionaryTest methodsFor: 'assertions' stamp: 'monty 10/18/2014 08:53'!
assertDictionary: aDictionary equals: aSecondDictionary
	self
		assert: aDictionary = aDictionary;
		assert: aSecondDictionary = aSecondDictionary;
		assert: aDictionary = aSecondDictionary;
		assert: aSecondDictionary = aDictionary! !

!StandardOrderedDictionaryTest methodsFor: 'assertions' stamp: 'JAAyer 1/19/2011 20:18'!
assertIsDictionary: anObject includesAll: anAssociationCollection
	self
		assert: (anObject isMemberOf: self dictionaryClass);
		assert: (anAssociationCollection allSatisfy: [:each | anObject includesAssociation: each])! !

!StandardOrderedDictionaryTest methodsFor: 'assertions' stamp: 'JAAyer 1/19/2011 20:18'!
assertIsDictionary: anObject withAssociations: anAssociationCollection
	self
		assert: (anObject isMemberOf: self dictionaryClass);
		assert: anObject associations = anAssociationCollection! !

!StandardOrderedDictionaryTest methodsFor: 'assertions' stamp: 'monty 12/15/2014 16:50'!
assertRemovedKey: aKey from: aDictionary
	self deny: (aDictionary includesKey: aKey).
	aDictionary keys asArray, aDictionary orderedKeys asArray do: [:each |
		self deny:
			(self isTestingIdentityDictionary
				ifTrue: [each == aKey]
				ifFalse: [each = aKey])].! !

!StandardOrderedDictionaryTest methodsFor: 'assertions' stamp: 'monty 12/14/2014 16:35'!
assertSelector: aSelector collects: aCollection from: aDictionary
	self
		assert: (self emptyDictionary perform: aSelector) asArray = #();
		assert: (aDictionary perform: aSelector) asArray = aCollection asArray! !

!StandardOrderedDictionaryTest methodsFor: 'assertions' stamp: 'JAAyer 12/6/2010 14:21'!
assertSelector: aSelector enumerates: aFirstCollection and: aSecondCollection from: aDictionary
	| firstEnumerated secondEnumerated|

	firstEnumerated := OrderedCollection new.
	secondEnumerated := OrderedCollection new.
	self emptyDictionary perform: aSelector with: [:first :second |
		firstEnumerated add: first.
		secondEnumerated add: second].
	self
		assert: firstEnumerated isEmpty;
		assert: secondEnumerated isEmpty.

	aDictionary perform: aSelector with: [:first :second |
		firstEnumerated add: first.
		secondEnumerated add: second].
	self
		assert: firstEnumerated asArray = aFirstCollection asArray;
		assert: secondEnumerated asArray = aSecondCollection asArray.! !

!StandardOrderedDictionaryTest methodsFor: 'assertions' stamp: 'JAAyer 12/6/2010 14:19'!
assertSelector: aSelector enumerates: aCollection from: aDictionary
	| enumerated |

	enumerated := OrderedCollection new.
	self emptyDictionary perform: aSelector with: [:each | enumerated add: each].
	self assert: enumerated isEmpty.

	aDictionary perform: aSelector with: [:each | enumerated add: each].
	self assert: enumerated asArray = aCollection asArray.! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 12/15/2014 16:36'!
defaultCapacity
	^ self emptyInternalDictionary capacity! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 12/15/2014 16:44'!
dictionaryAssociations
	self isTestingIdentityDictionary
		ifTrue: [^ self identityDictionaryAssociations]
		ifFalse: [^ self nonIdentityDictionaryAssociations]! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 11/20/2014 18:49'!
dictionaryClass
	^ StandardOrderedDictionary! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 12/5/2010 12:28'!
dictionaryKeys
	^ self dictionaryAssociations collect: [:each | each key]! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 12/5/2010 12:28'!
dictionaryValues
	^ self dictionaryAssociations collect: [:each | each value]! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 12/5/2010 02:17'!
dictionaryWithAssociations
	^ self dictionaryClass newFrom: self dictionaryAssociations! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/16/2011 13:58'!
dictionaryWithSingleAssociation
	^ self dictionaryClass with: self singleAssociation! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 12/5/2010 01:04'!
emptyDictionary
	^ self dictionaryClass new! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 12/15/2014 16:34'!
emptyInternalDictionary
	^ self internalDictionaryClass new! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 12/15/2014 16:10'!
identityAbsentKey
	^ self singleKey copy! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 11/20/2014 19:26'!
identityDictionaryAssociations
	"associations are copied so can be modified in one test without affecting others,
	but the keys and values are identical each time for identity tests."
	dictionaryAssociations
		ifNil: [| key |
			key := 'testKey'.
			dictionaryAssociations :=
				Array
					with: (key := key copy) -> 'testValue'
					with: (key := key copy) -> 'testValue3'
					with: (key := key copy) -> 'testValue2'
					with: (key := key copy) -> 'testValue4'].
	^ dictionaryAssociations collect: [:each | each copy].! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 12/15/2014 16:44'!
internalDictionaryClass
	self isTestingIdentityDictionary
		ifTrue: [^ IdentityDictionary]
		ifFalse: [^ Dictionary]! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 10/18/2014 09:43'!
internalDictionaryWithAssociations
	^ self internalDictionaryClass newFrom: self dictionaryAssociations! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 12/15/2014 16:37'!
internalDictionaryWithSingleAssociation
	^ self internalDictionaryClass with: self singleAssociation! !

!StandardOrderedDictionaryTest methodsFor: 'testing' stamp: 'monty 12/15/2014 16:44'!
isTestingIdentityDictionary
	^ false! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/19/2011 20:09'!
newKey
	^ 'newKey'! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/19/2011 20:09'!
newValue
	^ 'newValue'! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 12/15/2014 16:08'!
nonIdentityAbsentKey
	^ 'absentKey'! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 12/15/2014 16:08'!
nonIdentityDictionaryAssociations
	"Associations are grouped out of their natural sort order and
	are copied so can be modified in one test without affecting others,
	but the keys and values are identical each time for identity tests."
	dictionaryAssociations ifNil: [
		dictionaryAssociations :=
		Array
			with: 'testKey'->'testValue'
			with: 'testKey3'->'testValue3'
			with: 'testKey2'->'testValue2'
			with: 'testKey4'->'testValue4'].
	^ dictionaryAssociations collect: [:each | each copy].! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 12/21/2015 21:31'!
otherOrderPreservingDictionaryClasses
	^ StandardOrderedDictionary withAllSubclasses copyWithout: self dictionaryClass! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/16/2011 01:09'!
singleAssociation
	^ self dictionaryAssociations first! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/16/2011 01:09'!
singleKey
	^ self singleAssociation key! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/16/2011 01:09'!
singleValue
	^ self singleAssociation value! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/19/2011 20:20'!
testAdd
	| dictionary associationToReplace replacementAssociation |

	dictionary := self emptyDictionary.
	self
		deny: (self dictionaryAssociations anySatisfy: [:each | dictionary includesAssociation: each]);
		assert: (self dictionaryAssociations allSatisfy: [:each | (dictionary add: each) == each]);
		assert: (self dictionaryAssociations allSatisfy: [:each | dictionary includesAssociation: each]);
		assert: dictionary associations = self dictionaryAssociations.

	associationToReplace := self dictionaryAssociations anyOne.
	replacementAssociation := associationToReplace copy.
	replacementAssociation value: self newValue.
	self
		assert: (dictionary add: replacementAssociation) == replacementAssociation;
		assert: (dictionary includesAssociation: replacementAssociation);
		deny: (dictionary includesAssociation: associationToReplace).
	self
		assertIsDictionary: dictionary
		withAssociations: 
			(self dictionaryAssociations
				replaceAll: associationToReplace
				with: replacementAssociation).! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/19/2011 20:20'!
testAddAll
	| dictionary |

	dictionary := self emptyDictionary.
	self deny:
		(self dictionaryAssociations anySatisfy: [:each |
			dictionary includesAssociation: each]).

	self
		assert: (dictionary addAll: self dictionaryAssociations) = self dictionaryAssociations;
		assert: dictionary associations = self dictionaryAssociations.

	"ensure adding the same associations doesn't change the order"
	self assert:
		(dictionary addAll: self dictionaryAssociations reversed) =
			self dictionaryAssociations reversed.
	self assertIsDictionary: dictionary withAssociations: self dictionaryAssociations.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 18:50'!
testAssociationAt
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		should: [dictionary associationAt: self absentKey] raise: Error;
		assert: (dictionary associationAt: self singleKey) = self singleAssociation.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 00:44'!
testAssociationAtIfAbsent
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		assert: (dictionary associationAt: self absentKey ifAbsent: [self absentValue]) = self absentValue;
		assert: (dictionary associationAt: self singleKey ifAbsent: [self absentValue]) = self singleAssociation.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/19/2014 09:04'!
testAssociationAtIfPresent
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		assert: (dictionary associationAt: self absentKey ifPresent: [self absentValue]) isNil;
		assert: (dictionary associationAt: self singleKey ifPresent: [self newValue]) = self newValue.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:18'!
testAssociations
	self
		assertSelector: #associations
		collects: self dictionaryAssociations
		from: self dictionaryWithAssociations! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:20'!
testAssociationsDo
	self
		assertSelector: #associationsDo:
		enumerates: self dictionaryAssociations
		from: self dictionaryWithAssociations! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 18:51'!
testAssociationsSelect
	| dictionary selectedAssociations rejectedAssociation |

	rejectedAssociation := self dictionaryAssociations anyOne.
	selectedAssociations := self dictionaryAssociations copyWithout: rejectedAssociation.
	dictionary :=
		self dictionaryWithAssociations
			associationsSelect: [:each | each ~= rejectedAssociation].
	self
		assertIsDictionary: dictionary withAssociations: selectedAssociations;
		deny: (dictionary includesAssociation: rejectedAssociation).

	(dictionary associationsSelect: [:each | true])
		at: selectedAssociations anyOne key
		put: self newValue.
	self assertIsDictionary: dictionary withAssociations: selectedAssociations.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 18:53'!
testAt
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		should: [dictionary at: self absentKey] raise: Error;
		assert: (dictionary at: self singleKey) = self singleValue.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 00:50'!
testAtIfAbsent
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		assert: (dictionary at: self absentKey ifAbsent: [self absentValue]) = self absentValue;
		assert: (dictionary at: self singleKey ifAbsent: [self absentValue]) = self singleValue.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 13:59'!
testAtIfAbsentPut
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		assert: (dictionary at: self singleKey ifAbsentPut: [self newValue]) = self singleValue;
		assert: (dictionary at: self newKey ifAbsentPut: [self newValue]) = self newValue.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/18/2014 09:41'!
testAtIfPresent
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self assert:
		(dictionary
			at: self singleKey
			ifPresent: [:each |
				each = self singleValue
					ifTrue: [self newValue]
					ifFalse: [nil]]) = self newValue.
	self assert:
		(dictionary
			at: self absentKey
			ifPresent: [:each | self signalFailure: 'Block should not have been evaluated']) isNil.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/19/2014 09:10'!
testAtIfPresentIfAbsent
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self assert:
		(dictionary
			at: self singleKey
			ifPresent: [:value |
				value = self singleValue
					ifTrue: [self newValue]
					ifFalse: [nil]]
			ifAbsent: [self signalFailure: 'Block should not have been evaluated']) = self newValue.
	self assert:
		(dictionary
			at: self absentKey
			ifPresent: [self signalFailure: 'Block should not have been evaluated']
			ifAbsent: [self newValue]) = self newValue.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/18/2014 11:10'!
testAtPut
	| dictionary keyToUpdate oldValue |

	dictionary := self emptyDictionary.
	self assert:
		(self dictionaryAssociations allSatisfy: [:each |
			(dictionary at: each key put: each value) = each value]).
	self assert: dictionary associations = self dictionaryAssociations.

	keyToUpdate := self dictionaryKeys anyOne.
	oldValue := dictionary at: keyToUpdate.
	self
		assert: (dictionary at: keyToUpdate put: self newValue) = self newValue;
		assert: (dictionary at: keyToUpdate) = self newValue;
		assert:
			(dictionary associations =
				(self dictionaryAssociations collect: [:each |
					(each value = oldValue)
						ifTrue: [each key -> self newValue]
						ifFalse: [each]])).! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 18:55'!
testCapacity
	"The current Dictionary implementation allocations more than specified; the amount allocated may
	change in the future, but it likely won't ever be less than specified, so a >= test is used instead."
	| defaultCapacity |

	defaultCapacity := self defaultCapacity.
	self
		assert: (self dictionaryClass new) capacity >= defaultCapacity;
		assert:
			(self dictionaryClass new: (defaultCapacity / 2) asInteger) capacity >=
				(defaultCapacity / 2) asInteger;
		assert:
			(self dictionaryClass newFrom: self dictionaryAssociations)
				capacity >= self dictionaryAssociations size.

	0 to: self dictionaryAssociations size - 1 do: [:i |
		self
			shouldnt: [(self dictionaryClass new: i) addAll: self dictionaryAssociations]
			raise: Error].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 19:08'!
testCollect
	| dictionary |

	dictionary := self dictionaryWithAssociations.
	self
		assertIsDictionary: (dictionary collect: [:each | self newValue])
		withAssociations:
			(self dictionaryAssociations collect: [:each | each value: self newValue]).! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 19:09'!
testCopy
	| dictionary copy |

	dictionary := self dictionaryWithAssociations.
	copy := dictionary copy.
	self
		assertDictionary: dictionary equals: copy;
		deny: dictionary == copy;
		deny: dictionary dictionary == copy dictionary;
		deny: dictionary orderedKeys == copy orderedKeys.

	dictionary at: self singleKey put: self newValue.
	self deny: (copy at: self singleKey) = self newValue.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 19:10'!
testCopyEmpty
	| dictionary copy |

	dictionary := self dictionaryWithAssociations.
	copy := dictionary copyEmpty.
	self
		assertDictionary: dictionary doesNotEqual: copy;
		assert: copy isEmpty;
		deny: dictionary isEmpty.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 12/15/2014 16:43'!
testDictionary
	| dictionary |

	dictionary := self emptyDictionary.
	self
		assert: dictionary dictionary class == self internalDictionaryClass;
		assert: dictionary dictionary = self emptyInternalDictionary.
	dictionary := self dictionaryWithSingleAssociation.
	self
		assert: dictionary dictionary class == self internalDictionaryClass;
		assert: dictionary dictionary = self internalDictionaryWithSingleAssociation.
	dictionary := self dictionaryWithAssociations.
	self
		assert: dictionary dictionary class == self internalDictionaryClass;
		assert: dictionary dictionary = self internalDictionaryWithAssociations.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:20'!
testDo
	self
		assertSelector: #do:
		enumerates: self dictionaryValues
		from: self dictionaryWithAssociations! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/18/2014 11:27'!
testEquals
	| dictionaryOne dictionaryTwo |

	dictionaryOne := self emptyDictionary.
	dictionaryTwo := self emptyDictionary.
	self assertDictionary: dictionaryOne equals: dictionaryTwo.

	"For equality, order will not matter"
	self dictionaryAssociations
		with: self dictionaryAssociations reversed
		do: [:firstAssociation :secondAssociation |
			dictionaryOne add: firstAssociation.
			dictionaryTwo add: secondAssociation.
			self
				assertDictionary: dictionaryOne doesNotEqual: self emptyDictionary;
				assertDictionary: dictionaryTwo doesNotEqual: self emptyDictionary.
			dictionaryOne size < self dictionaryAssociations size
				ifTrue: [self assertDictionary: dictionaryOne doesNotEqual: dictionaryTwo]].

	self assertDictionary: dictionaryOne equals: dictionaryTwo.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 12/21/2015 21:25'!
testEqualsDictionary
	"cannot use assertDictionary:doesNotEqual: for backwards compatibility with
	older Pharo images where Dictionary>>= uses #isDictionary to test the argument
	because these classes also implement isDictionary"
	self
		deny: self emptyDictionary = self emptyInternalDictionary;
		deny: self dictionaryWithAssociations = self internalDictionaryWithAssociations! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/30/2015 12:12'!
testEqualsOtherOrderPreservingDictionaries
	self otherOrderPreservingDictionaryClasses do: [:otherClass | | dictionary otherDictionary |
		dictionary := self dictionaryClass new.
		otherDictionary := otherClass new.
		dictionary isIdentityDictionary = otherDictionary isIdentityDictionary
			ifTrue: [
				self
					assertDictionary: dictionary
					equals: otherDictionary.
				self dictionaryAssociations do: [:each |
					dictionary add: each.
					self
						assertDictionary: dictionary
						doesNotEqual: otherDictionary.
					otherDictionary add: each copy.
					self
						assertDictionary: dictionary
						equals: otherDictionary]]
			ifFalse: [
				self
					assertDictionary: dictionary
					doesNotEqual: otherDictionary.
				self dictionaryAssociations do: [:each |
					dictionary add: each.
					otherDictionary add: each copy.
					self
						assertDictionary: dictionary
						doesNotEqual: otherDictionary]]]! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 12/21/2015 21:33'!
testHash
	| dictionary otherDictionary internalDictionary otherInternalDictionary |

	dictionary := self emptyDictionary.
	otherDictionary := self emptyDictionary.
	internalDictionary := self emptyInternalDictionary.
	otherInternalDictionary := self emptyInternalDictionary.
	self assert: dictionary hash = otherDictionary hash.
	self dictionaryAssociations do: [:each |
		dictionary add: each.
		internalDictionary add: each copy.
		"if the internal hashes differ after adding to one, the external should too"
		internalDictionary hash = otherInternalDictionary hash
			ifFalse: [self deny: dictionary hash = otherDictionary hash].

		otherDictionary add: each copy.
		otherInternalDictionary add: each copy.
		"should be equal regardless now"
		self assert: dictionary hash = otherDictionary hash].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/30/2015 12:12'!
testHashOtherOrderPreservingDictionaries
	self otherOrderPreservingDictionaryClasses do: [:otherClass | | dictionary otherDictionary |
		dictionary := self dictionaryClass new.
		otherDictionary := otherClass new.
		dictionary isIdentityDictionary = otherDictionary isIdentityDictionary
			ifTrue: [
				self assert: dictionary hash = otherDictionary hash.
				self dictionaryAssociations do: [:each |
					dictionary add: each.
					otherDictionary add: each copy.
					self assert: dictionary hash = otherDictionary hash]]]! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 4/14/2015 02:33'!
testIdentityIndexOfKey
	| dictionary |

	dictionary := self dictionaryWithAssociations.
	dictionary keys withIndexDo: [:each :i |
		self
			assert: (dictionary identityIndexOfKey: each) = i;
			assert: (dictionary identityIndexOfKey: each copy) isZero].
	self assert: (dictionary identityIndexOfKey: self absentKey) isZero.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 4/14/2015 02:33'!
testIdentityIndexOfKeyIfAbsent
	| dictionary |

	dictionary := self dictionaryWithAssociations.
	dictionary keys withIndexDo: [:each :i |
		self
			assert: (dictionary identityIndexOfKey: each ifAbsent: [self absentValue]) = i;
			assert:
				(dictionary
					identityIndexOfKey: each copy
					ifAbsent: [self absentValue]) = self absentValue].

	self assert:
		(dictionary
			identityIndexOfKey: self absentKey
			ifAbsent: [self absentValue]) = self absentValue.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 14:27'!
testIncludes
	| dictionary |

	dictionary := self emptyDictionary.
	self deny: (self dictionaryValues anySatisfy: [:each | dictionary includes: each]).

	dictionary addAll: self dictionaryAssociations.
	self assert: (self dictionaryValues allSatisfy: [:each | dictionary includes: each]).! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/5/2010 02:58'!
testIncludesAssociation
	| dictionary |

	dictionary := self emptyDictionary.
	self deny: (self dictionaryAssociations anySatisfy: [:each | dictionary includesAssociation: each]).

	dictionary addAll: self dictionaryAssociations.
	self assert: (self dictionaryAssociations allSatisfy: [:each | dictionary includesAssociation: each])! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/18/2011 21:05'!
testIncludesIdentity
	| dictionary associations values |

	dictionary := self emptyDictionary.

	"Need to save references to the exact objects for identity tests"
	associations := self dictionaryAssociations.
	values := associations collect: [:each | each value].
	self deny: (values anySatisfy: [:each | dictionary includesIdentity: each ]).

	dictionary addAll: associations.
	self
		assert: (values allSatisfy: [:each | dictionary includesIdentity: each]);
		deny: (values anySatisfy: [:each | dictionary includesIdentity: each copy]).! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/19/2014 00:07'!
testIncludesKey
	| dictionary associations |

	dictionary := self emptyDictionary.
	self deny: (self dictionaryKeys anySatisfy: [:each | dictionary includesKey: each]).

	associations := self dictionaryAssociations asOrderedCollection.
	[associations notEmpty]
		whileTrue: [| addedAssociation |
			addedAssociation := dictionary add: associations removeFirst.
			self assert: (dictionary includesKey: addedAssociation key).

			associations do: [:each |
				self deny: (dictionary includesKey: each key)]].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 11/3/2014 18:42'!
testIndexOfKey
	| dictionary |

	dictionary := self dictionaryWithAssociations.
	dictionary keys withIndexDo: [:each :i |
		self assert: (dictionary indexOfKey: each) = i].
	self assert: (dictionary indexOfKey: self absentKey) isZero.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 4/14/2015 02:33'!
testIndexOfKeyIfAbsent
	| dictionary |

	dictionary := self dictionaryWithAssociations.
	dictionary keys withIndexDo: [:each :i |
		self assert: (dictionary indexOfKey: each ifAbsent: [self absentValue]) = i].

	self assert:
		(dictionary
			indexOfKey: self absentKey
			ifAbsent: [self absentValue]) = self absentValue.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 12:11'!
testIsDictionary
	self assert: self dictionaryClass new isDictionary! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/30/2015 11:44'!
testIsIdentityDictionary
	self assert: self emptyDictionary isIdentityDictionary = self isTestingIdentityDictionary! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 4/14/2015 03:21'!
testKeyAtIdentityValue
	| dictionary singleValue |

	dictionary := self dictionaryWithSingleAssociation.
	singleValue := dictionary at: self singleKey.
	self
		should: [dictionary keyAtIdentityValue: self absentValue] raise: Error;
		should: [dictionary keyAtIdentityValue: singleValue copy] raise: Error;
		assert: (dictionary keyAtIdentityValue: singleValue) = self singleKey.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 4/14/2015 03:21'!
testKeyAtIdentityValueIfAbsent
	| dictionary singleValue |

	dictionary := self dictionaryWithSingleAssociation.
	singleValue := dictionary at: self singleKey.
	self assert:
		(dictionary
			keyAtIdentityValue: self absentValue
			ifAbsent: [self absentKey]) = self absentKey.
	self assert:
		(dictionary
			keyAtIdentityValue: singleValue copy
			ifAbsent: [self absentKey]) = self absentKey.
	self assert:
		(dictionary
			keyAtValue: singleValue
			ifAbsent: [self absentKey]) = self singleKey.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 19:07'!
testKeyAtIndex
	| dictionary |

	self
		should: [self emptyDictionary keyAtIndex: 0] raise: Error;
		should: [self emptyDictionary keyAtIndex: 1] raise: Error.

	dictionary := self dictionaryWithAssociations.
	self dictionaryKeys withIndexDo: [:each :i |
		self assert: (dictionary keyAtIndex: i) = each].
	self
		should: [dictionary keyAtIndex: 0] raise: Error;
		should: [dictionary keyAtIndex: dictionary size + 1] raise: Error.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 11/3/2014 17:08'!
testKeyAtIndexIfAbsent
	| dictionary |

	dictionary := self emptyDictionary.
	self
		assert: (dictionary keyAtIndex: 0 ifAbsent: [self newKey]) = self newKey;
		assert: (dictionary keyAtIndex: 1 ifAbsent: [self newKey]) = self newKey.

	dictionary := self dictionaryWithAssociations.
	self dictionaryKeys withIndexDo: [:each :i |
		self assert: (dictionary keyAtIndex: i ifAbsent: [self newKey]) = each].
	self assert:
		(dictionary
			keyAtIndex: 0
			ifAbsent: [self newKey]) = self newKey.
	self assert:
			(dictionary
				keyAtIndex: dictionary size + 1
				ifAbsent: [self newKey]) = self newKey.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 18:59'!
testKeyAtValue
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		should: [dictionary keyAtValue: self absentValue] raise: Error;
		assert: (dictionary keyAtValue: self singleValue) = self singleKey.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 00:59'!
testKeyAtValueIfAbsent
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		assert: (dictionary keyAtValue: self absentValue ifAbsent: [self absentKey]) = self absentKey;
		assert: (dictionary keyAtValue: self singleValue ifAbsent: [self absentKey]) = self singleKey.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 01:05'!
testKeyForIdentity
	| dictionary value |

	dictionary := self dictionaryWithSingleAssociation.
	value := dictionary at: self singleKey.
	self
		assert: (dictionary keyForIdentity: value) = self singleKey;
		assert: (dictionary keyForIdentity: value copy) isNil;
		assert: (dictionary keyForIdentity: self absentValue) isNil.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:18'!
testKeys
	self
		assertSelector: #keys
		collects: self dictionaryKeys
		from: self dictionaryWithAssociations! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:21'!
testKeysAndValuesDo
	self
		assertSelector: #keysAndValuesDo:
		enumerates: self dictionaryKeys
		and: self dictionaryValues
		from: self dictionaryWithAssociations! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 11/14/2014 16:18'!
testKeysAndValuesRemove
	| dictionary keys |

	dictionary := self dictionaryWithAssociations.
	keys := self dictionaryKeys.
	dictionary keysAndValuesRemove: [:key :value | keys first = key or: [keys third = key]].

	self
		deny: (dictionary includesKey: keys first);
		deny: (dictionary includesKey: keys third);
		assert:
			(((keys copyWithout: keys first) copyWithout: keys third)
				allSatisfy: [:each | dictionary includesKey: each]).! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:20'!
testKeysDo
	self
		assertSelector: #keysDo:
		enumerates: self dictionaryKeys
		from: self dictionaryWithAssociations! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:18'!
testKeysSortedSafely
	"The keys are all strings, so the default #sorted implementation will suffice."
	self
		assertSelector: #keysSortedSafely
		collects: self dictionaryKeys sorted
		from: self dictionaryWithAssociations! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 19:14'!
testNewFrom
	| dictionaryOne dictionaryTwo dictionaryThree |
	
	dictionaryOne := self dictionaryClass newFrom: self dictionaryAssociations.
	dictionaryTwo := self dictionaryClass newFrom: dictionaryOne.
	dictionaryThree := self dictionaryClass newFrom: self internalDictionaryWithAssociations.
	self
		assertIsDictionary: dictionaryOne withAssociations: self dictionaryAssociations;
		assertIsDictionary: dictionaryTwo withAssociations: self dictionaryAssociations;
		assertIsDictionary: dictionaryThree includesAll: self dictionaryAssociations.

	(self dictionaryClass newFrom: dictionaryOne)
		at: self singleKey put: self newValue.
	self deny: (dictionaryOne at: self singleKey) = self newValue.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 11/14/2014 17:52'!
testNewFromPairs
	| pairs |

	pairs := OrderedCollection new.
	self dictionaryAssociations do: [:each |
		pairs
			add: each key;
			add: each value].
	0 to: pairs size do: [:i |
		self
			assertDictionary:
				(self dictionaryClass newFromPairs: (pairs copyFrom: 1 to: i))
			equals:
				(self dictionaryClass newFrom:
					(self dictionaryAssociations copyFrom: 1 to: (i / 2) floor))].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 17:34'!
testOccurancesOf
	| dictionary |

	dictionary := self emptyDictionary.
	self assert: (dictionary occurrencesOf: self absentValue) isZero.

	dictionary add: (self dictionaryAssociations first value: self newValue).
	self assert: (dictionary occurrencesOf: self newValue) = 1.

	dictionary add: (self dictionaryAssociations second value: self newValue) .
	self assert: (dictionary occurrencesOf: self newValue) = 2.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 11/13/2014 15:46'!
testRemoveAll
	| dictionary |

	dictionary := self dictionaryWithAssociations.
	self deny: dictionary isEmpty.
	dictionary removeAll.
	self
		assert: dictionary isEmpty;
		assert: (dictionary orderedKeys allSatisfy: [:each | each isNil]).
	dictionary addAll: self dictionaryAssociations.
	self deny: dictionary isEmpty.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 12/15/2014 15:58'!
testRemoveKey
	| dictionary associationsToRemove |

	dictionary := self dictionaryWithAssociations.
	self should: [dictionary removeKey: self absentKey] raise: Error.
	associationsToRemove := self dictionaryAssociations asOrderedCollection.
	[associationsToRemove notEmpty]
		whileTrue: [ | removed |
			removed := associationsToRemove removeFirst.
			self
				assert: (dictionary removeKey: removed key) = removed value;
				should: [dictionary removeKey: removed key] raise: Error;
				assertRemovedKey: removed key from: dictionary;
				assert: dictionary keys = (associationsToRemove collect: [:each | each key]) asArray].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 01:00'!
testRemoveKeyIfAbsent
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		assert: (dictionary removeKey: self absentKey ifAbsent: [self absentValue]) = self absentValue;
		assert: (dictionary removeKey: self singleKey ifAbsent: [self absentValue]) = self singleValue;
		deny: (dictionary includesKey: self singleKey).! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 4/14/2016 06:21'!
testRemoveKeys
	0 to: self dictionaryKeys size do: [:i | | dictionary keysToRemove dictionaryWithoutKeys |
		dictionary := self dictionaryWithAssociations.
		keysToRemove := (self dictionaryKeys copyFrom: 1 to: i) asSet.
		self assert: (dictionary removeKeys: keysToRemove) == dictionary.
	
		dictionaryWithoutKeys := self dictionaryWithAssociations.
		keysToRemove do: [:each | dictionaryWithoutKeys removeKey: each].
		self
			assertDictionary: dictionary
			equals: dictionaryWithoutKeys.
		self assert: dictionary keys = dictionaryWithoutKeys keys]! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 11/20/2014 18:56'!
testSelect
	| dictionary |

	dictionary := self dictionaryWithAssociations.
	self
		assertIsDictionary: (dictionary select: [:each | each ~= self singleValue])
		withAssociations: (self dictionaryAssociations copyWithout: self singleAssociation).

	(dictionary select: [:each | true]) at: self singleKey put: self newValue.
	self deny: (dictionary at: self singleKey) = self newValue.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 16:54'!
testSize
	| dictionary |

	dictionary := self emptyDictionary.
	self assert: dictionary size isZero.

	self dictionaryAssociations doWithIndex: [:each :i |
		dictionary add: each.
		self assert: dictionary size = i].

	self dictionaryAssociations size to: 1 by: -1 do: [:i |
		dictionary removeKey: (self dictionaryKeys at: i).
		self assert: dictionary size = (i - 1)].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:18'!
testValues
	self
		assertSelector: #values
		collects: self dictionaryValues
		from: self dictionaryWithAssociations! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:20'!
testValuesDo
	self
		assertSelector: #valuesDo:
		enumerates: self dictionaryValues
		from: self dictionaryWithAssociations! !

StandardOrderedDictionaryTest subclass: #StandardOrderedIdentityDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

!StandardOrderedIdentityDictionaryTest class methodsFor: 'testing' stamp: 'monty 11/20/2014 19:24'!
shouldInheritSelectors
	^ true! !

!StandardOrderedIdentityDictionaryTest methodsFor: 'accessing' stamp: 'monty 11/20/2014 19:24'!
dictionaryClass
	^ StandardOrderedIdentityDictionary! !

!StandardOrderedIdentityDictionaryTest methodsFor: 'testing' stamp: 'monty 12/15/2014 16:44'!
isTestingIdentityDictionary
	^ true! !
